image: docker:latest
services:
  - name: docker:dind
    alias: docker

stages:
  - Build image
  - Test acceptation
  - Release image
  - Deploy review
  - Stop review
  - Deploy staging
  - Deploy prod

build:
  # Official docker image.
  stage: Build image
  script:
    - docker build -t alpinehelloworld .
    - docker save alpinehelloworld > alpinehelloworld.tar
  artifacts:
    paths:
      - alpinehelloworld.tar


test acceptation:
  # Official docker image.
  stage: Test acceptation
  before_script:
    - apk --no-cache add curl
  script:
    - docker load < alpinehelloworld.tar
    - docker run -d -p 80:5000 -e PORT=5000 --name webapp alpinehelloworld
    - sleep 5
    - curl "http://docker" | grep -q "Hello world!"

release image:
  stage: Release image
  script:
    - docker load < alpinehelloworld.tar
    - docker tag alpinehelloworld "${IMAGE_NAME}:${CI_COMMIT_REF_NAME}"
    - docker tag alpinehelloworld "${IMAGE_NAME}:${CI_COMMIT_SHORT_SHA}"
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker push "${IMAGE_NAME}:${CI_COMMIT_REF_NAME}"
    - docker push "${IMAGE_NAME}:${CI_COMMIT_SHORT_SHA}"

deploy review:
  stage: Deploy review
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://korner-alpine-$CI_COMMIT_REF_NAME.herokuapp.com
    on_stop: stop review
  only:
    - merge_requests
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - heroku create korner-alpine-$CI_COMMIT_REF_NAME  || echo "project already exist"
    - heroku container:push -a korner-alpine-$CI_COMMIT_REF_NAME web
    - heroku container:release -a korner-alpine-$CI_COMMIT_REF_NAME web

stop review:
  stage: Stop review
  variables:
    GIT_STRATEGY: none
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
  only:
    - merge_requests
  when: manual
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - heroku apps:destroy -a korner-alpine-$CI_COMMIT_REF_NAME -c korner-alpine-$CI_COMMIT_REF_NAME

deploy staging:
  # Official docker image.
  stage: Deploy staging
  environment:
    name: staging
    url: https://korner-alpine-staging.heroku.com
  only: 
    - master
  before_script:
    - apk --no-cache add npm
    - npm install -g heroku
  script:
    - heroku container:login
    - heroku create korner-alpine-staging || echo "The name is already taken"
    - heroku container:push -a korner-alpine-staging web
    - heroku container:release -a korner-alpine-staging web

deploy prod:
  # Official docker image.
  stage: Deploy prod
  environment:
    name: staging
    url: https://korner-alpine-prod.heroku.com
  only: 
    - master
  before_script:
    - apk --no-cache add npm
    - npm install -g heroku
  script:
    - heroku container:login
    - heroku create korner-alpine-prod || echo "The name is already taken"
    - heroku container:push -a korner-alpine-prod web
    - heroku container:release -a korner-alpine-prod web

